#ifndef __32DIB32_H__
#define __32DIB32_H__

#include <windows.h>

#pragma comment(lib,"msimg32.lib")

#define DECLSPEC extern "C" __declspec( dllexport )

DECLSPEC BOOL	 b32Delete(HBITMAP hBmp);
DECLSPEC int	 b32GetWidth(HBITMAP hBmp);
DECLSPEC int	 b32GetHeight(HBITMAP hBmp);
DECLSPEC int	 b32GetBPP(HBITMAP hBmp);
DECLSPEC PBYTE	 b32GetBits(HBITMAP hBmp);
DECLSPEC HBITMAP b32New(int width, int height);
DECLSPEC HBITMAP b32Load(TCHAR *filename, int x = 0, int y = 0, int width = 0, int height = 0);
DECLSPEC BOOL	 b32Reload(HBITMAP hBmp, TCHAR *filename, int x = 0, int y = 0, int width = 0,
						   int height = 0);
DECLSPEC HBITMAP b32Get32bppDIB(HBITMAP hBmp, int x = 0, int y = 0, int width = 0, int height = 0);
DECLSPEC BOOL	 b32Draw(HBITMAP hBmpDst, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc = 0,
						 int ySrc = 0, int width = 0, int height = 0);
DECLSPEC BOOL	 b32DrawDC(HDC hDC, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc = 0,
						   int ySrc = 0, int width = 0, int height = 0);
DECLSPEC BOOL	 b32DrawEx(HBITMAP hBmpDst, int xDst, int yDst, int widthDst, int heightDst,
						   HBITMAP hBmpSrc, int xSrc = 0, int ySrc = 0, int widthSrc = 0, int heightSrc = 0);
DECLSPEC BOOL	 b32DrawKey(HBITMAP hBmpDst, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc, int ySrc,
							int width, int height, BYTE red, BYTE green, BYTE blue);
DECLSPEC BOOL	 b32DrawKeyDC(HDC hDC, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc, int ySrc,
							  int width, int height, BYTE red, BYTE green, BYTE blue);
DECLSPEC BOOL	 b32DrawKeyEx(HBITMAP hBmpDst, int xDst, int yDst, int widthDst, int heightDst,
							  HBITMAP hBmpSrc, int xSrc, int ySrc, int widthSrc, int heightSrc,
							  BYTE red, BYTE green, BYTE blue);
DECLSPEC BOOL	 b32DrawAlpha(HBITMAP hBmpDst, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc, int ySrc,
							  int width, int height, BYTE alpha);
DECLSPEC BOOL	 b32DrawAlphaDC(HDC hDC, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc, int ySrc,
								int width, int height, BYTE alpha);
DECLSPEC BOOL	 b32DrawAlphaEx(HBITMAP hBmpDst, int xDst, int yDst, int widthDst, int heightDst,
								HBITMAP hBmpSrc, int xSrc, int ySrc, int widthSrc, int heightSrc, BYTE alpha);
DECLSPEC BOOL	 b32Draw32(HBITMAP hBmpDst, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc = 0,
                           int ySrc = 0, int width = 0, int height = 0, BYTE alpha = 255);
DECLSPEC BOOL	 b32DrawAddAlpha(HBITMAP hBmpDst, int xDst, int yDst,
								 HBITMAP hBmpSrc, int xSrc, int ySrc, int width, int height,
								 BYTE alpha, BOOL bMinus = 0);
DECLSPEC BOOL	 b32DrawColor(HBITMAP hBmp, BYTE alpha, BYTE red, BYTE green, BYTE blue,
							  int x = 0, int y = 0, int width = 0, int height = 0);
DECLSPEC BOOL	 b32AddColor(HBITMAP hBmp, BYTE red, BYTE green, BYTE blue,
							 int x = 0, int y = 0, int width = 0, int height = 0, BOOL bMinus = 0);
DECLSPEC BOOL	 b32ChangeAlpha(HBITMAP hBmp, BYTE alpha, int x = 0, int y = 0, int width = 0, int height = 0);
DECLSPEC BOOL	 b32Monotone(HBITMAP hBmp, int x = 0, int y = 0, int width = 0, int height = 0);
DECLSPEC BOOL	 b32Hue(HBITMAP hBmp, int hue, int x = 0, int y = 0, int width = 0, int height = 0);
DECLSPEC void	 b32SetFont(TCHAR *strFontName, int iWeight, int iCharSet, int iPitchAndFamily, int iQuality,
							BYTE bItalic = 0, BYTE bUnderline = 0, BYTE bStrikeOut = 0);
DECLSPEC BOOL	 b32DrawFont(HBITMAP hBmp, TCHAR *str, int size, int x, int y, BYTE red, BYTE green, BYTE blue);
DECLSPEC BOOL	 b32DrawFontDC(HDC hDC, TCHAR *str, int size, int x, int y, BYTE red, BYTE green, BYTE blue);

#endif
