#define _CRT_SECURE_NO_WARNINGS
#include "32dib32.h"
#include <tchar.h>

#define MULT1	255		// |ZΉ\̔搔̍ől
#define MULT2	255		// |ZΉ\̏搔̍őligMultTbl1j
#define MULT3	64		// |ZΉ\̏搔̍őligMultTbl2j
#define DIV1	255 * 3 // ZΉ\̔폜̍ől

BYTE	gMultTbl1[MULT1+1][MULT2+1];	// |ZΉ\1
BYTE	gMultTbl2[MULT1+1][MULT3+1];	// |ZΉ\2
WORD	gDivTbl[DIV1+1];				// ZΉ\
LOGFONT glFont;

void b32Init();
RECT b32Clip(int x, int y, int width, int height, int wdhDib, int hgtDib);

extern "C" int APIENTRY DllMain( HINSTANCE hInst, DWORD dwReason, LPVOID lpRsv )
{
	switch(dwReason)
	{
	case DLL_PROCESS_ATTACH:
		b32Init();
		break;
	}
	return TRUE;
}

// 
void b32Init()
{
	// tHg
	ZeroMemory(&glFont, sizeof(glFont));
	_tcsncpy(glFont.lfFaceName, TEXT("lr SVbN"), sizeof(glFont.lfFaceName));
	glFont.lfWeight 		= 700;
	glFont.lfCharSet		= SHIFTJIS_CHARSET;
	glFont.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;
	glFont.lfQuality		= ANTIALIASED_QUALITY;
	// |ZΉ\쐬
	int i, j;
	for(i=0; i<=MULT1; i++){
		for(j=0; j<=MULT2; j++){
			gMultTbl1[i][j]  = (i * j) / MULT2;
		}
	}
	for(i=0; i<=MULT1; i++){
		for(j=0; j<=MULT3; j++){
			gMultTbl2[i][j]  = (i * j) / MULT3;
		}
	}
	// ZΉ\쐬
	for(i=0; i<=DIV1; i++){
		gDivTbl[i]  = i / 3;
	}
}// b32Init

// rbg}bvnh̉
// hBmp		: [IN]	rbg}bvnh
// ߂l	:		1:A0:s
BOOL b32Delete(HBITMAP hBmp)
{
	BOOL res = FALSE;
	
	if(hBmp){
		if(DeleteObject(hBmp)){
			hBmp = NULL;
			res = TRUE;
		}
	}
	return res;
}// b32Delete

// DIB ̉摜擾
// hBmp   : [IN] rbg}bvnh
// ߂l :      摜
int b32GetWidth(HBITMAP hBmp)
{
	BITMAP bmp;
	
	GetObject(hBmp, sizeof(BITMAP), &bmp);
	
	return bmp.bmWidth;
}// b32GetWidth

// DIB ̉摜擾
// hBmp   : [IN] rbg}bvnh
// ߂l :      摜̍
int b32GetHeight(HBITMAP hBmp)
{
	BITMAP bmp;
	
	GetObject(hBmp, sizeof(BITMAP), &bmp);
	
	return bmp.bmHeight;
}// b32GetHeight

// DIB ̐F[x擾
// hBmp   : [IN] rbg}bvnh
// ߂l :      摜̐F[x
int b32GetBPP(HBITMAP hBmp)
{
	BITMAP bmp;
	
	GetObject(hBmp, sizeof(BITMAP), &bmp);
	
	return bmp.bmBitsPixel;
}// b32GetBPP

// DIB ̃sNZl擾
// hBmp   : [IN] rbg}bvnh
// ߂l :      摜̃sNZl
PBYTE b32GetBits(HBITMAP hBmp)
{
	BITMAP bmp;
	
	GetObject(hBmp, sizeof(BITMAP), &bmp);
	
	return (PBYTE) bmp.bmBits;
}// b32GetBits

// 32bppDIB ̐VK쐬
// width	: [IN]	摜̕
// height	: [IN]	摜̍
// ߂l	:		rbg}bvnh
HBITMAP b32New(int width, int height)
{
	BITMAPINFO	bi;
	LPBYTE		buf;
	
	ZeroMemory(&bi, sizeof(bi));
	bi.bmiHeader.biSize 		= sizeof(BITMAPINFOHEADER);
	bi.bmiHeader.biWidth		= width;
	bi.bmiHeader.biHeight		= - height;
	bi.bmiHeader.biPlanes		= 1;
	bi.bmiHeader.biBitCount 	= 32;
	bi.bmiHeader.biCompression	= BI_RGB;
	
	HBITMAP hBmp = (HBITMAP) CreateDIBSection(NULL, &bi, DIB_RGB_COLORS, (VOID**) &buf, NULL, 0);
	
	return hBmp;
}// b32New

// 摜 32bppDIB ɓǂݍ
// filename : [IN]	rbg}bv t@C
// x, y 	: [IN]	ǂݍ݋`̍W
// width	: [IN]	ǂݍ݋`̕i0 ̏ꍇ͉摜̕j
// height	: [IN]	ǂݍ݋`̍i0 ̏ꍇ͉摜̍j
// ߂l	:		rbg}bvnh
HBITMAP b32Load(TCHAR *filename, int x, int y, int width, int height)
{
	BITMAP	bmp;
	HBITMAP hBmpIn,hBmpOut;
	
	hBmpIn = (HBITMAP) LoadImage(NULL, filename, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_CREATEDIBSECTION);
	if(hBmpIn == NULL) return NULL;
	
	GetObject(hBmpIn, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hBmpOut = b32New(width, height);
	
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpOut);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmpIn);
		BitBlt(hdcCp1, 0, 0, width, height, hdcCp2, x, y, SRCCOPY);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	DeleteObject(hBmpIn);
	
	if(bmp.bmBitsPixel < 32){
		b32ChangeAlpha(hBmpOut, 255);
	}
	
	return hBmpOut;
}// b32Load

// 摜̍ēǂݍ
// hBmp 	: [IN]	rbg}bvnh
// filename : [IN]	rbg}bv t@C
// x, y 	: [IN]	ǂݍ݋`̍W
// width	: [IN]	ǂݍ݋`̕i0 ̏ꍇ͉摜̕j
// height	: [IN]	ǂݍ݋`̍i0 ̏ꍇ͉摜̍j
// ߂l	:		1:A0:s
BOOL b32Reload(HBITMAP hBmp, TCHAR *filename, int x, int y, int width, int height)
{
	BOOL	res = FALSE;
	BITMAP	bmp;
	HBITMAP hBmpIn;
	
	hBmpIn = (HBITMAP) LoadImage(NULL, filename, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_CREATEDIBSECTION);
	if(hBmpIn == NULL) return FALSE;
	
	GetObject(hBmpIn, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmp);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmpIn);
		BitBlt(hdcCp1, 0, 0, width, height, hdcCp2, x, y, SRCCOPY);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	DeleteObject(hBmpIn);
	
	if(bmp.bmBitsPixel < 32){
		b32ChangeAlpha(hBmp, 255);
	}
	
	return res;
}// b32Reload

// 32bppDIB 擾
// hBmp		: [IN]	ɂȂrbg}bvnh
// x, y 	: [IN]	ǂݍ݋`̍W
// width	: [IN]	ǂݍ݋`̕i0 ̏ꍇ͉摜̕j
// height	: [IN]	ǂݍ݋`̍i0 ̏ꍇ͉摜̍j
// ߂l	:		rbg}bvnh
HBITMAP b32Get32bppDIB(HBITMAP hBmp, int x, int y, int width, int height)
{
	BITMAP	bmp;
	HBITMAP hBmpOut;
	
	GetObject(hBmp, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hBmpOut = b32New(width, height);
	
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpOut);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmp);
		BitBlt(hdcCp1, 0, 0, width, height, hdcCp2, x, y, SRCCOPY);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return hBmpOut;
}// b32Load

// DIB ̕`iHBITMAPj
// hBmpDst		: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst	: [IN]		Rs[W
// hBmpSrc		: [IN]		Rs[rbg}bvnh
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// ߂l		:			1:A0:s
BOOL b32Draw(HBITMAP hBmpDst, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc, int ySrc,
			int width, int height)
{
	if(!hBmpDst || !hBmpSrc) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	BITMAP	bmp;
	
	GetObject(hBmpSrc, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpDst);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmpSrc);
		BitBlt(hdcCp1, xDst, yDst, width, height, hdcCp2, xSrc, ySrc, SRCCOPY);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return res;
}// b32Draw

// DIB ̕`ifoCXReLXgj
// hDC			: [IN][OUT] Rs[foCXReLXg
// xDst, yDst	: [IN]		Rs[W
// hBmpSrc 		: [IN]		Rs[rbg}bvnh
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// ߂l		:			1:A0:s
BOOL b32DrawDC(HDC hDC, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc, int ySrc,
			   int width, int height)
{
	if(!hDC || !hBmpSrc) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp;
	HBITMAP hbmpPre;
	BITMAP	bmp;
	
	GetObject(hBmpSrc, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hdcCp = CreateCompatibleDC(hDC);
	if(hdcCp){
		hbmpPre = (HBITMAP) SelectObject(hdcCp, hBmpSrc);
		BitBlt(hDC, xDst, yDst, width, height, hdcCp, xSrc, ySrc, SRCCOPY);
		SelectObject(hdcCp, hbmpPre);
		DeleteDC(hdcCp);
		res = TRUE;
	}
	
	return res;
}// b32DrawDC

// DIB ̕`igEkj
// hBmpDst				: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst			: [IN]		Rs[W
// widthDst, heightDst	: [IN]		Rs[`̕ƍ
// hBmpSrc				: [IN]		Rs[rbg}bvnh
// xSrc, ySrc			: [IN]		Rs[W
// widthSrc, heightSrc	: [IN]		Rs[`̕ƍ
// ߂l				:			1:A0:s
BOOL b32DrawEx(HBITMAP hBmpDst, int xDst, int yDst, int widthDst, int heightDst,
			   HBITMAP hBmpSrc, int xSrc, int ySrc, int widthSrc, int heightSrc)
{
	if(!hBmpDst || !hBmpSrc) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	BITMAP	bmp;
	
	GetObject(hBmpSrc, sizeof(bmp), &bmp);
	if(widthSrc <= 0)	widthSrc  = bmp.bmWidth;
	if(heightSrc <= 0)	heightSrc = bmp.bmHeight;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpDst);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmpSrc);
		StretchBlt(hdcCp1, xDst, yDst, widthDst, heightDst, hdcCp2, xSrc, ySrc, widthSrc, heightSrc, SRCCOPY);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return res;
}// b32DrawEx

// DIB ̔F`iHBITMAPj
// hBmpDst		: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst	: [IN]		Rs[W
// hBmpSrc		: [IN]		Rs[rbg}bvnh
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// red			: [IN]		F̐ԐF
// green		: [IN]		F̗ΐF
// blue 		: [IN]		F̐F
// ߂l		:			1:A0:s
BOOL b32DrawKey(HBITMAP hBmpDst, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc, int ySrc,
				int width, int height, BYTE red, BYTE green, BYTE blue)
{
	if(!hBmpDst || !hBmpSrc) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	BITMAP	bmp;
	
	GetObject(hBmpSrc, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpDst);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmpSrc);
		TransparentBlt(hdcCp1, xDst, yDst, width, height, hdcCp2, xSrc, ySrc, width, height, RGB(red, green, blue));
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return res;
}// b32DrawKey

// DIB ̔F`ifoCXReLXgj
// hDC			: [IN][OUT] Rs[foCXReLXg
// xDst, yDst	: [IN]		Rs[W
// hBmpSrc 		: [IN]		Rs[rbg}bvnh
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// red			: [IN]		ԐF
// green		: [IN]		ΐF
// blue 		: [IN]		F
// ߂l		:			1:A0:s
BOOL b32DrawKeyDC(HDC hDC, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc, int ySrc,
				  int width, int height, BYTE red, BYTE green, BYTE blue)
{
	if(!hDC || !hBmpSrc) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp;
	HBITMAP hbmpPre;
	BITMAP	bmp;
	
	GetObject(hBmpSrc, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hdcCp = CreateCompatibleDC(hDC);
	if(hdcCp){
		hbmpPre = (HBITMAP) SelectObject(hdcCp, hBmpSrc);
		TransparentBlt(hDC, xDst, yDst, width, height, hdcCp, xSrc, ySrc, width, height, RGB(red, green, blue));
		SelectObject(hdcCp, hbmpPre);
		DeleteDC(hdcCp);
		res = TRUE;
	}
	
	return res;
}// b32DrawKeyDC

// DIB ̔F`igEkj
// hBmpDst				: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst			: [IN]		Rs[W
// widthDst, heightDst	: [IN]		Rs[`̕ƍ
// hBmpSrc				: [IN]		Rs[rbg}bvnh
// xSrc, ySrc			: [IN]		Rs[W
// widthSrc, heightSrc	: [IN]		Rs[`̕ƍ
// red					: [IN]		F̐ԐF
// green				: [IN]		F̗ΐF
// blue 				: [IN]		F̐F
// ߂l				:			1:A0:s
BOOL b32DrawKeyEx(HBITMAP hBmpDst, int xDst, int yDst, int widthDst, int heightDst,
				  HBITMAP hBmpSrc, int xSrc, int ySrc, int widthSrc, int heightSrc,
				  BYTE red, BYTE green, BYTE blue)
{
	if(!hBmpDst || !hBmpSrc) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	BITMAP	bmpSrc,bmpDst;
	
	GetObject(hBmpSrc, sizeof(bmpSrc), &bmpSrc);
	if(widthSrc <= 0)	widthSrc  = bmpSrc.bmWidth;
	if(heightSrc <= 0)	heightSrc = bmpSrc.bmHeight;
	GetObject(hBmpDst, sizeof(bmpDst), &bmpDst);
	if(widthDst <= 0)	widthDst  = bmpDst.bmWidth;
	if(heightDst <= 0)	heightDst = bmpDst.bmHeight;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpDst);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmpSrc);
		TransparentBlt(hdcCp1, xDst, yDst, widthDst, heightDst, hdcCp2, xSrc, ySrc, widthSrc, heightSrc, RGB(red, green, blue));
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return res;
}// b32DrawKeyEx

// DIB ̔`iHBITMAPj
// hBmpDst		: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst	: [IN]		Rs[W
// hBmpSrc		: [IN]		Rs[rbg}bvnh
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// alpha		: [IN]		Ŝ̓xi0 - 255j
// ߂l		:			1:A0:s
BOOL b32DrawAlpha(HBITMAP hBmpDst, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc, int ySrc,
				  int width, int height, BYTE alpha)
{
	if(!hBmpDst || !hBmpSrc) return FALSE;
	
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	if(alpha == 0)	return FALSE;
	
	BOOL			res = FALSE;
	HDC 			hdcCp1,hdcCp2;
	HBITMAP 		hbmOld1,hbmOld2;
	BITMAP			bmp;
	BLENDFUNCTION	bf;
	
	bf.BlendOp				= AC_SRC_OVER;
	bf.BlendFlags			= 0;
	bf.SourceConstantAlpha	= alpha;
	bf.AlphaFormat			= 0;
	
	GetObject(hBmpSrc, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpDst);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmpSrc);
		AlphaBlend(hdcCp1, xDst, yDst, width, height, hdcCp2, xSrc, ySrc, width, height, bf);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return res;
}// b32DrawAlpha

// DIB ̔`ifoCXReLXgj
// hDC			: [IN][OUT] Rs[foCXReLXg
// xDst, yDst	: [IN]		Rs[W
// hBmpSrc 		: [IN]		Rs[rbg}bvnh
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// alpha		: [IN]		Ŝ̓xi0 - 255j
// ߂l		:			1:A0:s
BOOL b32DrawAlphaDC(HDC hDC, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc, int ySrc,
					int width, int height, BYTE alpha)
{
	if(!hDC || !hBmpSrc) return FALSE;
	
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	if(alpha == 0)	return FALSE;
	
	BOOL			res = FALSE;
	HDC 			hdcCp;
	HBITMAP 		hbmpPre;
	BITMAP			bmp;
	BLENDFUNCTION	bf;
	
	bf.BlendOp				= AC_SRC_OVER;
	bf.BlendFlags			= 0;
	bf.SourceConstantAlpha	= alpha;
	bf.AlphaFormat			= 0;
	
	GetObject(hBmpSrc, sizeof(bmp), &bmp);
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	
	hdcCp = CreateCompatibleDC(hDC);
	if(hdcCp){
		hbmpPre = (HBITMAP) SelectObject(hdcCp, hBmpSrc);
		AlphaBlend(hDC, xDst, yDst, width, height, hdcCp, xSrc, ySrc, width, height, bf);
		SelectObject(hdcCp, hbmpPre);
		DeleteDC(hdcCp);
		res = TRUE;
	}
	
	return res;
}// b32DrawAlphaDC

// DIB ̔`igEkj
// hBmpDst				: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst			: [IN]		Rs[W
// widthDst, heightDst	: [IN]		Rs[`̕ƍ
// hBmpSrc				: [IN]		Rs[rbg}bvnh
// xSrc, ySrc			: [IN]		Rs[W
// widthSrc, heightSrc	: [IN]		Rs[`̕ƍ
// alpha				: [IN]		Ŝ̓xi0 - 255j
// ߂l				:			1:A0:s
BOOL b32DrawAlphaEx(HBITMAP hBmpDst, int xDst, int yDst, int widthDst, int heightDst,
					HBITMAP hBmpSrc, int xSrc, int ySrc, int widthSrc, int heightSrc, BYTE alpha)
{
	if(!hBmpDst || !hBmpSrc) return FALSE;
	
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	if(alpha == 0)	return FALSE;
	
	BOOL			res = FALSE;
	HDC 			hdcCp1,hdcCp2;
	HBITMAP 		hbmOld1,hbmOld2;
	BITMAP			bmpSrc,bmpDst;
	BLENDFUNCTION	bf;
	
	bf.BlendOp				= AC_SRC_OVER;
	bf.BlendFlags			= 0;
	bf.SourceConstantAlpha	= alpha;
	bf.AlphaFormat			= 0;
	
	GetObject(hBmpSrc, sizeof(bmpSrc), &bmpSrc);
	if(widthSrc <= 0)	widthSrc  = bmpSrc.bmWidth;
	if(heightSrc <= 0)	heightSrc = bmpSrc.bmHeight;
	GetObject(hBmpDst, sizeof(bmpDst), &bmpDst);
	if(widthDst <= 0)	widthDst  = bmpDst.bmWidth;
	if(heightDst <= 0)	heightDst = bmpDst.bmHeight;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	if(hdcCp1 && hdcCp2){
		hbmOld1 = (HBITMAP)SelectObject(hdcCp1, hBmpDst);
		hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmpSrc);
		AlphaBlend(hdcCp1, xDst, yDst, widthDst, heightDst, hdcCp2, xSrc, ySrc, widthSrc, heightSrc, bf);
		SelectObject(hdcCp1, hbmOld1);
		SelectObject(hdcCp2, hbmOld2);
		res = TRUE;
	}
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	
	return res;
}// b32DrawAlphaEx

// 32bppDIB ̓x`
// hBmpDst		: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst	: [IN]		Rs[W
// hBmpSrc		: [IN]		Rs[rbg}bvnh
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// alpha		: [IN]		Ŝ̓xi0 - 255j
// ߂l		:			1:A0:s
BOOL b32Draw32(HBITMAP hBmpDst, int xDst, int yDst, HBITMAP hBmpSrc,
			   int xSrc, int ySrc, int width, int height, BYTE alpha)
{
	if(!hBmpDst || !hBmpSrc) return FALSE;
	
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	if(alpha == 0)	return FALSE;
	
	BITMAP	bmpSrc,bmpDst;
	GetObject(hBmpSrc, sizeof(bmpSrc), &bmpSrc);
	GetObject(hBmpDst, sizeof(bmpDst), &bmpDst);
	if(bmpSrc.bmBitsPixel != 32)	return FALSE;
	if(bmpDst.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmpSrc.bmWidth;
	if(height <= 0) height = bmpSrc.bmHeight;
	
	int wdhSrc = bmpSrc.bmWidth;
	int hgtSrc = bmpSrc.bmHeight;
	int wdhDst = bmpDst.bmWidth;
	int hgtDst = bmpDst.bmHeight;
	
	RECT rc = b32Clip(xSrc, ySrc, width, height, wdhSrc, hgtSrc);
	
	int 	i, j, sum_r, sum_g, sum_b, dst_x, dst_y;
	DWORD	ba;
	BYTE	br, bg, bb, sa, sa2, sr, sg, sb;
	
	PDWORD	ps = (PDWORD) b32GetBits(hBmpSrc) + rc.top * wdhSrc;
	PDWORD	pb = (PDWORD) b32GetBits(hBmpDst) + yDst * wdhDst;
	int		width_rest_src = wdhSrc - rc.right;
	int		width_rest_dst = wdhDst - (rc.right + (xDst - rc.left));
	for(i = rc.top; i < rc.bottom; i++){
		ps += rc.left;
		pb += xDst;
		dst_y = i + yDst - rc.top;
		for(j = rc.left; j < rc.right; j++){
			dst_x = j + xDst - rc.left;
			if(dst_x >= 0 && dst_y >= 0 && dst_x >= xDst && dst_y >= yDst && dst_x < wdhDst && dst_y < hgtDst){
				ba = *pb & 0xff000000;
				br = (BYTE)(*pb >> 16);
				bg = (BYTE)(*pb >> 8);
				bb = (BYTE) *pb;
				sa = (BYTE)(*ps >> 24);
				sr = (BYTE)(*ps >> 16);
				sg = (BYTE)(*ps >> 8);
				sb = (BYTE) *ps;
				if(alpha < 255){
					sa  = gMultTbl1[sa][alpha];
				}
				sa2 = 255 - sa;
				sum_r = gMultTbl1[br][sa2] + gMultTbl1[sr][sa];
				sum_g = gMultTbl1[bg][sa2] + gMultTbl1[sg][sa];
				sum_b = gMultTbl1[bb][sa2] + gMultTbl1[sb][sa];
				if(sum_r > 255) sum_r = 255;
				if(sum_g > 255) sum_g = 255;
				if(sum_b > 255) sum_b = 255;
				*pb = ba | (sum_r << 16) | (sum_g << 8) | sum_b;
			}
			ps ++;
			pb ++;
		}
		ps += width_rest_src;
		pb += width_rest_dst;
	}
	
	return TRUE;
}// b32Draw32

// 32bppDIB ̉Z`
// hBmpDst		: [IN][OUT] Rs[rbg}bvnh
// xDst, yDst	: [IN]		Rs[W
// hBmpSrc		: [IN]		Rs[rbg}bvnh
// xSrc, ySrc	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// alpha		: [IN]		Ŝ̓xi0 - 255j
// bMinus		: [IN]		ZtOi0:ZA1:Zj
// ߂l		:			1:A0:s
BOOL b32DrawAddAlpha(HBITMAP hBmpDst, int xDst, int yDst, HBITMAP hBmpSrc, int xSrc, int ySrc,
					 int width, int height, BYTE alpha, BOOL bMinus)
{
	if(!hBmpDst || !hBmpSrc) return FALSE;
	
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	if(alpha == 0)	return FALSE;
	
	BITMAP	bmpSrc,bmpDst;
	GetObject(hBmpSrc, sizeof(bmpSrc), &bmpSrc);
	GetObject(hBmpDst, sizeof(bmpDst), &bmpDst);
	if(bmpSrc.bmBitsPixel != 32)	return FALSE;
	if(bmpDst.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmpSrc.bmWidth;
	if(height <= 0) height = bmpSrc.bmHeight;
	
	int wdhSrc = bmpSrc.bmWidth;
	int hgtSrc = bmpSrc.bmHeight;
	int wdhDst = bmpDst.bmWidth;
	int hgtDst = bmpDst.bmHeight;
	
	RECT rc = b32Clip(xSrc, ySrc, width, height, wdhSrc, hgtSrc);
	
	int 	i, j, sum_r, sum_g, sum_b, dst_x, dst_y;
	DWORD	ba;
	BYTE	br, bg, bb, sr, sg, sb;
	
	PDWORD	ps = (PDWORD) b32GetBits(hBmpSrc) + rc.top * wdhSrc;
	PDWORD	pb = (PDWORD) b32GetBits(hBmpDst) + yDst * wdhDst;
	int		width_rest_src = wdhSrc - rc.right;
	int		width_rest_dst = wdhDst - (rc.right + (xDst - rc.left));
	for(i = rc.top; i < rc.bottom; i++){
		ps += rc.left;
		pb += xDst;
		dst_y = i + yDst - rc.top;
		for(j = rc.left; j < rc.right; j++){
			dst_x = j + xDst - rc.left;
			if(dst_x >= 0 && dst_y >= 0 && dst_x >= xDst && dst_y >= yDst && dst_x < wdhDst && dst_y < hgtDst){
				ba = *pb & 0xff000000;
				br = (BYTE)(*pb >> 16);
				bg = (BYTE)(*pb >> 8);
				bb = (BYTE) *pb;
				sr = (BYTE)(*ps >> 16);
				sg = (BYTE)(*ps >> 8);
				sb = (BYTE) *ps;
				if(!bMinus){
					sum_r = br + gMultTbl1[sr][alpha];	// br + sr * alpha / 255 ̂
					sum_g = bg + gMultTbl1[sg][alpha];
					sum_b = bb + gMultTbl1[sb][alpha];
					if(sum_r > 255) sum_r = 255;
					if(sum_g > 255) sum_g = 255;
					if(sum_b > 255) sum_b = 255;
				}
				else{
					sum_r = br - gMultTbl1[sr][alpha];
					sum_g = bg - gMultTbl1[sg][alpha];
					sum_b = bb - gMultTbl1[sb][alpha];
					if(sum_r < 0) sum_r = 0;
					if(sum_g < 0) sum_g = 0;
					if(sum_b < 0) sum_b = 0;
				}
				*pb = ba | (sum_r << 16) | (sum_g << 8) | sum_b;
			}
			ps ++;
			pb ++;
		}
		ps += width_rest_src;
		pb += width_rest_dst;
	}
	
	return TRUE;
}// b32DrawAddAlpha

// 32bppDIB ̒PFhԂ
// hBmp 		: [IN][OUT] rbg}bvnh
// alpha		: [IN]		x
// red			: [IN]		ԐF
// green		: [IN]		ΐF
// blue 		: [IN]		F
// x, y 		: [IN]		`̍W
// width, height: [IN]		`̕ƍ
// ߂l		:			1:A0:s
BOOL b32DrawColor(HBITMAP hBmp, BYTE alpha, BYTE red, BYTE green, BYTE blue,
				  int x, int y, int width, int height)
{
	if(!hBmp) return FALSE;
	
	// rbg}bv擾Ɖ摜̕ƍ̐ݒ
	BITMAP	bmp;
	GetObject(hBmp, sizeof(bmp), &bmp);
	if(bmp.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	// eF 0 ` 255 ͈̔͂ɐݒ
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	if(red < 0)		red = 0;
	if(red > 255)	red = 255;
	if(green < 0)	green = 0;
	if(green > 255)	green = 255;
	if(blue < 0)	blue = 0;
	if(blue > 255)	blue = 255;
	// NbsO
	RECT rc = b32Clip(x, y, width, height, bmp.bmWidth, bmp.bmHeight);
	// h荞
	int 	i, j;
	DWORD	color = (alpha << 24) | (red << 16) | (green << 8) | blue;
	PDWORD	pb = (PDWORD) b32GetBits(hBmp) + rc.top * bmp.bmWidth;
	int		width_rest = bmp.bmWidth - rc.right;
	for(i = rc.top; i < rc.bottom; i++){
		pb += rc.left;
		for(j = rc.left; j < rc.right; j++){
			*pb = color;
			pb ++;
		}
		pb += width_rest;
	}
	
	return TRUE;
}// b32DrawColor

// 32bppDIB ̒PFZhԂ
// red			: [IN]		ԐF
// green		: [IN]		ΐF
// blue 		: [IN]		F
// x, y 		: [IN]		`̍W
// width, height: [IN]		`̕ƍ
// bMinus		: [IN]		ZtOi0:ZA1:Zj
// ߂l		:			1:A0:s
BOOL b32AddColor(HBITMAP hBmp, BYTE red, BYTE green, BYTE blue,
				int x, int y, int width, int height, BOOL bMinus)
{
	if(!hBmp) return FALSE;
	
	// rbg}bv擾Ɖ摜̕ƍ̐ݒ
	BITMAP	bmp;
	GetObject(hBmp, sizeof(bmp), &bmp);
	if(bmp.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	// eF 0 ` 255 ͈̔͂ɐݒ
	if(red < 0)		red = 0;
	if(red > 255)	red = 255;
	if(green < 0)	green = 0;
	if(green > 255)	green = 255;
	if(blue < 0)	blue = 0;
	if(blue > 255)	blue = 255;
	// NbsO
	RECT rc = b32Clip(x, y, width, height, bmp.bmWidth, bmp.bmHeight);
	// h荞
	int 	i, j, na, nr, ng, nb;
	PDWORD	pb = (PDWORD) b32GetBits(hBmp) + rc.top * bmp.bmWidth;
	int		width_rest = bmp.bmWidth - rc.right;
	for(i = rc.top; i < rc.bottom; i++){
		pb += rc.left;
		for(j = rc.left; j < rc.right; j++){
			na = *pb & 0xff000000;
			if(!bMinus){
				nr = (BYTE)(*pb >> 16) + red;
				ng = (BYTE)(*pb >> 8)  + green;
				nb = (BYTE) *pb        + blue;
				if(nr > 255)	nr = 255;
				if(ng > 255)	ng = 255;
				if(nb > 255)	nb = 255;
			}
			else{
				nr = (BYTE)(*pb >> 16) - red;
				ng = (BYTE)(*pb >> 8)  - green;
				nb = (BYTE) *pb        - blue;
				if(nr < 0)	nr = 0;
				if(ng < 0)	ng = 0;
				if(nb < 0)	nb = 0;
			}
			*pb = na | (nr << 16) | (ng << 8) | nb;
			pb ++;
		}
		pb += width_rest;
	}
	
	return TRUE;
}// b32AddColor

// 32bppDIB ̓xꗥύX
// hBmp 		: [IN][OUT] rbg}bvnh
// alpha		: [IN]		x
// x, y 		: [IN]		`̍W
// width, height: [IN]		`̕ƍ
// ߂l		:			1:A0:s
BOOL b32ChangeAlpha(HBITMAP hBmp, BYTE alpha, int x, int y, int width, int height)
{
	if(!hBmp) return FALSE;
	
	// rbg}bv擾Ɖ摜̕ƍ̐ݒ
	BITMAP	bmp;
	GetObject(hBmp, sizeof(bmp), &bmp);
	if(bmp.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	// eF 0 ` 255 ͈̔͂ɐݒ
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	// NbsO
	RECT rc = b32Clip(x, y, width, height, bmp.bmWidth, bmp.bmHeight);
	// h荞
	int 	i, j;
	DWORD	color = alpha << 24;
	PDWORD	pb = (PDWORD) b32GetBits(hBmp) + rc.top * bmp.bmWidth;
	int		width_rest = bmp.bmWidth - rc.right;
	for(i = rc.top; i < rc.bottom; i++){
		pb += rc.left;
		for(j = rc.left; j < rc.right; j++){
			*pb &= 0x00FFFFFF;
			*pb |= color;
			pb ++;
		}
		pb += width_rest;
	}
	
	return TRUE;
}// b32ChangeAlpha

// 32bppDIB ̃mN
// hBmp 		: [IN][OUT] rbg}bvnh
// x, y 		: [IN]		`̍W
// width, height: [IN]		`̕ƍ
// ߂l		:			1:A0:s
BOOL b32Monotone(HBITMAP hBmp, int x, int y, int width, int height)
{
	if(!hBmp) return FALSE;
	
	// rbg}bv擾Ɖ摜̕ƍ̐ݒ
	BITMAP	bmp;
	GetObject(hBmp, sizeof(bmp), &bmp);
	if(bmp.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	// NbsO
	RECT rc = b32Clip(x, y, width, height, bmp.bmWidth, bmp.bmHeight);
	// h荞
	DWORD	a;
	BYTE	r, g, b;
	int 	i, j, color;
	PDWORD	pb = (PDWORD) b32GetBits(hBmp) + rc.top * bmp.bmWidth;
	int		width_rest = bmp.bmWidth - rc.right;
	for(i = rc.top; i < rc.bottom; i++){
		pb += rc.left;
		for(j = rc.left; j < rc.right; j++){
			a = *pb & 0xff000000;
			r = (BYTE)(*pb >> 16);
			g = (BYTE)(*pb >> 8);
			b = (BYTE) *pb;
			color = gDivTbl[r + g + b];
//			if(color > 255)	color = 255;
			r = g = b = color;
			*pb = a | (r << 16) | (g << 8) | b;
			pb ++;
		}
		pb += width_rest;
	}
	
	return TRUE;
}// b32Monotone

// 32bppDIB ̐FϊiHBITMAPj
// hBmp 		: [IN][OUT] rbg}bvnh
// hue			: [IN]		F[g 0 - 192i32F, 96F, 144Fj
// x, y 		: [IN]		`̍W
// width, height: [IN]		`̕ƍ
// ߂l		:			1:A0:s
BOOL b32Hue(HBITMAP hBmp, int hue, int x, int y, int width, int height)
{
	if(!hBmp) return FALSE;
	
	// rbg}bv擾Ɖ摜̕ƍ̐ݒ
	BITMAP	bmp;
	GetObject(hBmp, sizeof(bmp), &bmp);
	if(bmp.bmBitsPixel != 32)	return FALSE;
	if(width <= 0)	width  = bmp.bmWidth;
	if(height <= 0) height = bmp.bmHeight;
	// F[gݒ
	if (hue > 192)		hue = 192;
	else if (hue <	0)	hue = 0;
	int hue2 = 64 - hue;
	int hue3 = hue - 64;
	int hue4 = 128 - hue;
	int hue5 = hue - 128;
	int hue6 = 192 - hue;
	// NbsO
	RECT rc = b32Clip(x, y, width, height, bmp.bmWidth, bmp.bmHeight);
	// Fϊ
	DWORD	a;
	BYTE	r, g, b;
	BYTE	fr1, fr2, fg1, fg2, fb1, fb2;
	int 	i, j;
	PDWORD	pb = (PDWORD) b32GetBits(hBmp) + rc.top * bmp.bmWidth;
	int		width_rest = bmp.bmWidth - rc.right;
	for(i = rc.top; i < rc.bottom; i++){
		pb += rc.left;
		for(j = rc.left; j < rc.right; j++){
			a = *pb & 0xff000000;
			r = (BYTE)(*pb >> 16);
			g = (BYTE)(*pb >> 8);
			b = (BYTE) *pb;
			if(hue >= 0 && hue <= 64){
				fr1 = gMultTbl2[r][hue];	// r * hue / 64 ̂
				fr2 = gMultTbl2[r][hue2];
				fg1 = gMultTbl2[g][hue];
				fg2 = gMultTbl2[g][hue2];
				fb1 = gMultTbl2[b][hue];
				fb2 = gMultTbl2[b][hue2];
			}
			else if(hue > 64 && hue <= 128){
				fr1 = gMultTbl2[b][hue3];
				fr2 = gMultTbl2[b][hue4];
				fg1 = gMultTbl2[r][hue3];
				fg2 = gMultTbl2[r][hue4];
				fb1 = gMultTbl2[g][hue3];
				fb2 = gMultTbl2[g][hue4];
			}
			else if(hue > 128 && hue <= 192){
				fr1 = gMultTbl2[g][hue5];
				fr2 = gMultTbl2[g][hue6];
				fg1 = gMultTbl2[b][hue5];
				fg2 = gMultTbl2[b][hue6];
				fb1 = gMultTbl2[r][hue5];
				fb2 = gMultTbl2[r][hue6];
			}
			r = fr2 + fb1;
			g = fg2 + fr1;
			b = fb2 + fg1;
			if(r > 255)	r = 255;
			if(g > 255)	g = 255;
			if(b > 255)	b = 255;
			*pb = a | (r << 16) | (g << 8) | b;
			pb ++;
		}
		pb += width_rest;
	}
	
	return TRUE;
}// b32Hue

// `̗L͈͂擾
// xDst, yDst		: [IN]	Rs[W
// xSrc, ySrc		: [IN]	Rs[W
// width, height	: [IN]	Rs[`̕ƍ
// wdhDib, hgtDib	: [IN]	DIB̕ƍ
// ߂l			:		`̗L͈
RECT b32Clip(int x, int y, int width, int height, int wdhDib, int hgtDib)
{
	RECT	rc = {x, y, x + width, y + height};
	
	if(rc.left < 0) 		rc.left 	= 0;
	if(rc.top < 0)			rc.top		= 0;
	if(rc.right > wdhDib)	rc.right	= wdhDib;
	if(rc.bottom > hgtDib)	rc.bottom	= hgtDib;
	if(rc.right <= rc.left) rc.right	= 0;
	if(rc.bottom <= rc.top) rc.bottom	= 0;
	
	return rc;
}// b32Clip

// tHgݒ
// strFontName		: [IN]	tHg
// iWeight			: [IN]	iO`XOOj
// iCharSet 		: [IN]	Zbg
// iPitchAndFamily	: [IN]	Œ蕝tHgƃtHgt@~[
// iQuality 		: [IN]	i
void b32SetFont(TCHAR *strFontName, int iWeight, int iCharSet, int iPitchAndFamily, int iQuality,
				BYTE bItalic, BYTE bUnderline, BYTE bStrikeOut)
{
	ZeroMemory(&glFont, sizeof(glFont));
	_tcsncpy(glFont.lfFaceName, strFontName, sizeof(glFont.lfFaceName));
	glFont.lfWeight 		= (int)  iWeight;
	glFont.lfCharSet		= (int)  iCharSet;
	glFont.lfPitchAndFamily = (int)  iPitchAndFamily;
	glFont.lfQuality		= (int)  iQuality;
	glFont.lfItalic			= (BYTE) bItalic;
	glFont.lfUnderline		= (BYTE) bUnderline;
	glFont.lfStrikeOut		= (BYTE) bStrikeOut;
}// b32SetFont

// ̕`iHBITMAPj
// hBmp 	: [IN][OUT] rbg}bvnh
// str		: [IN]		
// size 	: [IN]		TCY
// x,y		: [IN]		\ʒu
// red		: [IN]		ԐF
// green	: [IN]		ΐF
// blue 	: [IN]		F
// ߂l	:			1:A0:s
BOOL b32DrawFont(HBITMAP hBmp, TCHAR *str, int size, int x, int y, BYTE red, BYTE green, BYTE blue)
{
	if(!hBmp) return FALSE;
	
	BOOL	res = FALSE;
	HDC 	hdcCp;
	HBITMAP hbmOld;
	HFONT	fontNew,fontOld;
	
	glFont.lfHeight = size;
	
	hdcCp = CreateCompatibleDC(NULL);
	if(hdcCp){
		hbmOld = (HBITMAP)SelectObject(hdcCp, hBmp);
		fontNew = CreateFontIndirect(&glFont);
		fontOld = (HFONT)SelectObject(hdcCp, fontNew);
		
		SetBkMode(hdcCp, TRANSPARENT);
		SetTextColor(hdcCp, RGB(red, green, blue));
		TextOut(hdcCp, x, y, str, lstrlen(str));
		
		SelectObject(hdcCp, hbmOld);
		SelectObject(hdcCp, fontOld);
		DeleteObject(fontNew);
		DeleteDC(hdcCp);
		res = TRUE;
	}
	
	return res;
}// b32DrawFont

// ̕`ifoCXReLXgj
// hDC		: [IN][OUT] foCXReLXg
// str		: [IN]		
// size 	: [IN]		TCY
// x,y		: [IN]		\ʒu
// red		: [IN]		ԐF
// green	: [IN]		ΐF
// blue 	: [IN]		F
// ߂l	:			1:A0:s
BOOL b32DrawFontDC(HDC hDC, TCHAR *str, int size, int x, int y, BYTE red, BYTE green, BYTE blue)
{
	BOOL	res = FALSE;
	HFONT	fontNew,fontOld;
	
	if(hDC){
		glFont.lfHeight = size;
		
		fontNew = CreateFontIndirect(&glFont);
		fontOld = (HFONT)SelectObject(hDC, fontNew);
		
		SetBkMode(hDC, TRANSPARENT);
		SetTextColor(hDC, RGB(red, green, blue));
		TextOut(hDC, x, y, str, lstrlen(str));
		
		SelectObject(hDC, fontOld);
		DeleteObject(fontNew);
		res = TRUE;
	}
	
	return res;
}// b32DrawFontDC
